您的位置:首页 > 其它

POJ Meteor Shower(BFS)

2017-11-29 20:51 393 查看
点击打开题目链接

Meteor Shower
Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 19992Accepted: 5189
Description

Bessie hears that an extraordinary meteor shower is coming; reports say that these meteors will crash into earth and destroy anything they hit. Anxious for her safety, she vows to find her way to a safe
location (one that is never destroyed by a meteor) . She is currently grazing at the origin in the coordinate plane and wants to move to a new, safer location while avoiding being destroyed by meteors along her way.

The reports say that M meteors (1 ≤ M ≤ 50,000) will strike, with meteor i will striking point (Xi, Yi)
(0 ≤ Xi ≤ 300; 0 ≤ Yi ≤
300) at time Ti (0 ≤ Ti 
≤ 1,000). Each meteor destroys the point that it strikes and also the four rectilinearly adjacent lattice points.

Bessie leaves the origin at time 0 and can travel in the first quadrant and parallel to the axes at the rate of one distance unit per second to any of the (often 4) adjacent rectilinear points that are
not yet destroyed by a meteor. She cannot be located on a point at any time greater than or equal to the time it is destroyed).

Determine the minimum time it takes Bessie to get to a safe place.

Input

* Line 1: A single integer: M

* Lines 2..M+1: Line i+1 contains three space-separated integers: Xi, Yi,
and Ti

Output

* Line 1: The minimum time it takes Bessie to get to a safe place or -1 if it is impossible.

Sample Input
4
0 0 2
2 1 2
1 1 2
0 3 5


Sample Output
5


Source
USACO
2008 February Silver
[Submit]  
[Go Back]   [Status]  
[Discuss]


Home
Page   

Go
Back  

To
top

题目大意:

有一场流星雨要降临,给定流星雨落得位置和时间,最初Bessie在坐标原点上,求她到达安全地点所需要的时间。流星雨落下来后除去落到当前坐标,还会覆盖相邻上下左右四个点。

思路:

每分钟更新地图的方法显然不可取,所以最初令地图上所有点为-1,之后改为时间值,大于这个时间值才可行。构图完后再用宽搜BFS做即可。

 #include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;
const int maxn=300+5;
int map[maxn][maxn];
int dx[]={0, 0, 1, 0, -1},dy[]={0, 1, 0, -1, 0};
int x,y,t;
int M;

struct node{
int x, y, t;
};

int bfs(){
if(map[0][0]==-1)return 0;
else if(map[0][0]==0) return -1;
queue<node>Q;
node temp,now;
temp.x=temp.y=temp.t=0;
Q.push(temp);
while(!Q.empty()){
now=Q.front();
Q.pop();
for(int i=0;i<5;i++){
temp.x=now.x+dx[i];
temp.y=now.y+dy[i];
temp.t=now.t+1;
if(temp.x>=0&&temp.x<maxn&&temp.y>=0&&temp.y<maxn){
if(temp.t<map[temp.x][temp.y]){
map[temp.x][temp.y]=temp.t;
Q.push(temp);
}
else if(map[temp.x][temp.y]==-1){
return temp.t;
}
}
}
}
return -1;
}

int main(){
while(~scanf("%d",&M)){
memset(map,-1,sizeof(map));
for(int i=0;i<M;i++){
scanf("%d%d%d",&x,&y,&t);
for(int i=0;i<5;i++){
int tempx=x+dx[i];
int tempy=y+dy[i];
if(tempx>=0&&tempx<maxn&&tempy>=0&&tempy<maxn){
if(map[tempx][tempy]>t||map[tempx][tempy]==-1)
map[tempx][tempy]=t;
}
}
}
printf("%d\n",bfs());
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: